import { ButtonInteraction, CacheType } from "discord.js";
import { ButtonEvent } from "../type/buttonEvent";
import { CoreClient } from "../client/client";
import { PaginatedCommand } from "../type/paginatedCommand";

export default class Pagination extends ButtonEvent {
    public override async execute(interaction: ButtonInteraction<CacheType>) {
        const embedId = interaction.customId.split(' ')[1];
        const action = interaction.customId.split(' ')[2];

        const commandItem = CoreClient.commandItems.find(x => x.Name == embedId);
        const command = commandItem?.Command as PaginatedCommand;

        switch (action) {
            case "next":
                await command.nextPage(interaction);
                break;
            case "previous":
                await command.previousPage(interaction);
                break;
        }
    }
}