import EmbedPage from "../type/embedPage";

export default class PaginatedEmbed<TPage extends EmbedPage> {
    public Id: string;
    public CurrentPageIndex: number;
    public Pages: TPage[];

    constructor(id: string) {
        this.Id = id;
        this.CurrentPageIndex = 0;
        this.Pages = [];
    }

    public AddPages(...pages: TPage[]) {
        this.Pages.push(...pages);
    }

    public GetCurrentPage(): TPage | undefined {
        if (this.Pages.length == 0) {
            return;
        }

        return this.Pages[this.CurrentPageIndex];
    }

    public NextPage(): TPage | undefined {
        if (this.Pages.length == 0) {
            return;
        }

        if (this.CurrentPageIndex == this.Pages.length - 1) {
            return;
        }

        this.CurrentPageIndex++;
        return this.GetCurrentPage();
    }

    public PreviousPage(): TPage | undefined {
        if (this.Pages.length == 0) {
            return;
        }

        if (this.CurrentPageIndex == 0) {
            return;
        }

        this.CurrentPageIndex--;
        return this.GetCurrentPage();
    }
}